Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.ka2ddo.yaac.io
Class NonshareableByteArrayOutputStream

    java.lang.Object
      java.io.OutputStream
          org.ka2ddo.yaac.io.NonshareableByteArrayOutputStream

All Implemented Interfaces:
  java.io.Closeable, java.io.Flushable

    public class NonshareableByteArrayOutputStream

extends java.io.OutputStream

This class is a stripped-down version of the JRE's ByteArrayOutputStream, which allows direct access to the underlying byte array instead of making copies, is not synchronized (for speed), and doesn't do String conversions.

Field Summary
`protected byte[]` | `buf` The buffer where data is stored.
`protected int` | `count` The number of valid bytes in the buffer.

Constructor Summary
`NonshareableByteArrayOutputStream(int size)` Creates a new byte array output stream, with a buffer capacity of the specified size, in bytes.

Method Summary
`void` | `close()` Closing a `ByteArrayOutputStream` has no effect.
`byte[]` | `getByteArray()` Returns a reference to the current contents of this output stream; bytes at or past the index == size() are undefined.
`void` | `reset()` Resets the `count` field of this byte array output stream to zero, so that all currently accumulated output in the output stream is discarded.
`int` | `size()` Returns the current usage of the buffer.
`void` | `write(byte[] b, int off, int len)` Writes `len` bytes from the specified byte array starting at offset `off` to this byte array output stream.
`void` | `write(int b)` Writes the specified byte to this byte array output stream.
`void` | `writeTo(java.io.OutputStream out)` Writes the complete contents of this byte array output stream to the specified output stream argument, as if by calling the output stream's write method using `out.write(buf, 0, count)`.

Methods inherited from class java.io.OutputStream
`flush, write`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### buf

    protected byte[] buf

  The buffer where data is stored.

### count

    protected int count

  The number of valid bytes in the buffer.

Constructor Detail

### NonshareableByteArrayOutputStream

    public NonshareableByteArrayOutputStream(int size)

  Creates a new byte array output stream, with a buffer capacity of the specified size, in bytes.

  Parameters:
    `size` - the initial size.
  Throws:
    `java.lang.IllegalArgumentException` - if size is negative.

Method Detail

### write

    public void write(int b)

  Writes the specified byte to this byte array output stream.

  Specified by:
    `write` in class `java.io.OutputStream`
  Parameters:
    `b` - the byte to be written.

### write

    public void write(byte[] b,
                      int off,
                      int len)

  Writes `len` bytes from the specified byte array starting at offset `off` to this byte array output stream.

  Overrides:
    `write` in class `java.io.OutputStream`
  Parameters:
    `b` - the data.
    `off` - the start offset in the data.
    `len` - the number of bytes to write.

### writeTo

    public void writeTo(java.io.OutputStream out)
                 throws java.io.IOException

  Writes the complete contents of this byte array output stream to the specified output stream argument, as if by calling the output stream's write method using `out.write(buf, 0, count)`.

  Parameters:
    `out` - the output stream to which to write the data.
  Throws:
    `java.io.IOException` - if an I/O error occurs.

### reset

    public void reset()

  Resets the `count` field of this byte array output stream to zero, so that all currently accumulated output in the output stream is discarded. The output stream can be used again, reusing the already allocated buffer space.

### getByteArray

    public byte[] getByteArray()

  Returns a reference to the current contents of this output stream; bytes at or past the index == size() are undefined.

  Returns:
    the current contents of this output stream, as a byte array.
  See Also:
    `size()`

### size

    public int size()

  Returns the current usage of the buffer. Note this can be less than the actual internal array size, as the array is expanded in chunks to minimize heap thrashing.

  Returns:
    the value of the `count` field, which is the number of valid bytes in this output stream.

### close

    public void close()
               throws java.io.IOException

  Closing a `ByteArrayOutputStream` has no effect. The methods in this class can be called after the stream has been closed without generating an `IOException`.

  Specified by:
    `close` in interface `java.io.Closeable`
  Overrides:
    `close` in class `java.io.OutputStream`
  Throws:
    `java.io.IOException`

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD